;Things To Do v1.0 del 28/11/05
;2005 All Right Reserved
;Written by |Wolf|
;http://wolfprojects.altervista.org/

dialog todo {
  size -1 -1 300 340
  title "Things To Do v1.0"
  list 1, 0 0 300 270, hsbar vsbar extsel
  combo 2, 0 256 300 20
  button "Add", 3, 0 280 80 40, default
  button "Remove", 4, 100 280 100 20
  button "Close", 5, 200 300 100 20
  button "Sort", 6, 100 300 100 20
  button "Clear", 7, 200 280 100 20
  button "/\", 8, 80 280 20 20
  button "\/", 9, 80 300 20 20
  text "|Wolf| - 2005 All Right Reserved -", 10, 20 325 175 15, disable
  link "wolfprojects.org", 11, 196 325 100 15
}

alias todo { dialog -m todo todo }
alias todo.cl {
  if (%todo.y > 320) {
    dec %todo.y
    dialog -s todo $dialog(todo).x $dialog(todo).y  300 %todo.y
    .timertodo -m 1 20 todo.cl
  }
  else {
    unset %todo.y
  }
}

on *:load: todo

on *:dialog:todo:init:0: {
  var %todo.ln $lines(todo.txt)
  var %todo.k 1
  while (%todo.k <= %todo.ln) {
    did -a todo 1 $read(todo.txt,%todo.k)
    inc %todo.k
  }
  did -f todo 2
  did -z todo 1
  set %todo.y 340
  .timertodo 1 5 todo.cl
}

on *:dialog:todo:sclick:3: {
  if ($did(2)) {
    did -a todo 1 $did(2)
    did -r todo 2
    did -z todo 1
  }
}

on *:dialog:todo:sclick:4:{
  if ($did(1,0).sel > 1) {
    var %todo.k 1
    while ($did(1,%todo.k).sel) {
      did -d todo 1 $did(1,%todo.k).sel
    }
  }
  elseif ($did(1,0).sel == 1) {
    did -d todo 1 $did(1).sel
    did -z todo 1
  }
}

on *:dialog:todo:sclick:5: {
  write -c todo.txt
  var %todo.k 1
  while ($did(todo,1,%todo.k)) {
    write todo.txt $did(todo,1,%todo.k)
    inc %todo.k
  }
  dialog -x todo todo
}

on *:dialog:todo:sclick:6: filter -caio todo 1 todo 1 alias

on *:dialog:todo:sclick:7: {
  if ($?!="Clear list?") {
    did -r todo 1
    did -z todo 1
  }
}

on *:dialog:todo:sclick:8: {
  if ($did(todo,1).sel > 1) {
    var %todo.sc $did(todo,1).seltext
    var %todo.n $did(todo,1).sel
    did -d todo 1 %todo.n
    dec %todo.n
    did -i todo 1 %todo.n %todo.sc
    did -c todo 1 %todo.n
  }
}

on *:dialog:todo:sclick:9: {
  if ($did(todo,1).sel < $did(todo,1).lines) {
    var %todo.sc $did(todo,1).seltext
    var %todo.n $did(todo,1).sel
    did -d todo 1 %todo.n
    inc %todo.n
    did -i todo 1 %todo.n %todo.sc
    did -c todo 1 %todo.n
  }
}

on *:dialog:todo:sclick:11: url -n http://wolfprojects.altervista.org/

on *:dialog:todo:close:0: {
  write -c todo.txt
  var %todo.k 1
  while ($did(todo,1,%todo.k)) {
    write todo.txt $did(todo,1,%todo.k)
    inc %todo.k
  }
}
